--- JoglPipelineOLD.java	2016-11-07 16:27:54.000000000 +0100
+++ JoglPipeline.java	2017-12-28 22:54:49.000000000 +0100
@@ -4909,14 +5204,6 @@
         // in the bindTexture call
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // TextureRetained methods
-    // Texture2DRetained methods
-    //
-
     @Override
     void bindTexture2D(Context ctx, int objectId, boolean enable) {
         if (VERBOSE) System.err.println("JoglPipeline.bindTexture2D(objectId=" + objectId + ",enable=" + enable + ")");
@@ -4935,25 +5222,31 @@
 
     @Override
     void updateTexture2DImage(Context ctx,
-            int numLevels, int level,
-            int textureFormat, int imageFormat,
-            int width, int height,
-            int boundaryWidth,
-            int dataType, Object data, boolean useAutoMipMap) {
-        if (VERBOSE) System.err.println("JoglPipeline.updateTexture2DImage(width=" + width + ",height=" + height + ",level=" + level + ")");
+                              int numLevels, int level,
+                              int textureFormat, int imageFormat,
+                              int width, int height,
+                              int boundaryWidth,
+                              int dataType, Object data, boolean useAutoMipMap) {
+        if (VERBOSE)
+            System.err.println("JoglPipeline.updateTexture2DImage(width=" + width + ",height=" + height + ",level=" + level + ")");
 
         updateTexture2DImage(ctx, GL.GL_TEXTURE_2D,
                 numLevels, level, textureFormat, imageFormat,
                 width, height, boundaryWidth, dataType, data, useAutoMipMap);
     }
 
+    //----------------------------------------------------------------------
+    //
+    // Helper routines for above texture methods
+    //
+
     @Override
     void updateTexture2DSubImage(Context ctx,
-            int level, int xoffset, int yoffset,
-            int textureFormat, int imageFormat,
-            int imgXOffset, int imgYOffset,
-            int tilew, int width, int height,
-            int dataType, Object data, boolean useAutoMipMap) {
+                                 int level, int xoffset, int yoffset,
+                                 int textureFormat, int imageFormat,
+                                 int imgXOffset, int imgYOffset,
+                                 int tilew, int width, int height,
+                                 int dataType, Object data, boolean useAutoMipMap) {
 
         /* Note: useAutoMipMap is not use for SubImage in the jogl pipe */
 
@@ -4968,8 +5261,8 @@
 
     @Override
     void updateTexture2DLodRange(Context ctx,
-            int baseLevel, int maximumLevel,
-            float minimumLOD, float maximumLOD) {
+                                 int baseLevel, int maximumLevel,
+                                 float minimumLOD, float maximumLOD) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture2DLodRange()");
 
         updateTextureLodRange(ctx, GL.GL_TEXTURE_2D,
@@ -4979,8 +5272,8 @@
 
     @Override
     void updateTexture2DLodOffset(Context ctx,
-            float lodOffsetS, float lodOffsetT,
-            float lodOffsetR) {
+                                  float lodOffsetS, float lodOffsetT,
+                                  float lodOffsetR) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture2DLodOffset()");
 
         updateTextureLodOffset(ctx, GL.GL_TEXTURE_2D,
@@ -4989,9 +5282,9 @@
 
     @Override
     void updateTexture2DBoundary(Context ctx,
-            int boundaryModeS, int boundaryModeT,
-            float boundaryRed, float boundaryGreen,
-            float boundaryBlue, float boundaryAlpha) {
+                                 int boundaryModeS, int boundaryModeT,
+                                 float boundaryRed, float boundaryGreen,
+                                 float boundaryBlue, float boundaryAlpha) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture2DBoundary()");
 
         updateTextureBoundary(ctx, GL.GL_TEXTURE_2D,
@@ -5002,7 +5295,7 @@
 
     @Override
     void updateTexture2DFilterModes(Context ctx,
-            int minFilter, int magFilter) {
+                                    int minFilter, int magFilter) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture2DFilterModes()");
 
         updateTextureFilterModes(ctx, GL.GL_TEXTURE_2D, minFilter, magFilter);
@@ -5010,8 +5303,8 @@
 
     @Override
     void updateTexture2DSharpenFunc(Context ctx,
-            int numSharpenTextureFuncPts,
-            float[] sharpenTextureFuncPts) {
+                                    int numSharpenTextureFuncPts,
+                                    float[] sharpenTextureFuncPts) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture2DSharpenFunc()");
 
         updateTextureSharpenFunc(ctx, GL.GL_TEXTURE_2D,
@@ -5020,8 +5313,8 @@
 
     @Override
     void updateTexture2DFilter4Func(Context ctx,
-            int numFilter4FuncPts,
-            float[] filter4FuncPts) {
+                                    int numFilter4FuncPts,
+                                    float[] filter4FuncPts) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture2DFilter4Func()");
 
         updateTextureFilter4Func(ctx, GL.GL_TEXTURE_2D,
@@ -5035,10 +5328,16 @@
         updateTextureAnisotropicFilter(ctx, GL.GL_TEXTURE_2D, degree);
     }
 
+    // ---------------------------------------------------------------------
+
+    //
+    // MasterControl methods
+    //
+
     private void updateTextureLodRange(Context ctx,
-            int target,
-            int baseLevel, int maximumLevel,
-            float minimumLOD, float maximumLOD) {
+                                       int target,
+                                       int baseLevel, int maximumLevel,
+                                       float minimumLOD, float maximumLOD) {
         GL gl = context(ctx).getGL();
         // checking of the availability of the extension is already done
         // in the shared code
@@ -5048,10 +5347,17 @@
         gl.glTexParameterf(target, GL2.GL_TEXTURE_MAX_LOD, maximumLOD);
     }
 
+
+    // ---------------------------------------------------------------------
+
+    //
+    // Canvas3D methods - native wrappers
+    //
+
     private void updateTextureLodOffset(Context ctx,
-            int target,
-            float lodOffsetS, float lodOffsetT,
-            float lodOffsetR) {
+                                        int target,
+                                        float lodOffsetS, float lodOffsetT,
+                                        float lodOffsetR) {
 // FIXME: GL_SGIX_texture_lod_bias
 //        GL gl = context(ctx).getGL();
         // checking of the availability of the extension is already done
@@ -5070,12 +5376,6 @@
                 degree);
     }
 
-    // ---------------------------------------------------------------------
-
-    //
-    // Texture3DRetained methods
-    //
-
     @Override
     void bindTexture3D(Context ctx, int objectId, boolean enable) {
         if (VERBOSE) System.err.println("JoglPipeline.bindTexture3D()");
@@ -5094,15 +5394,15 @@
 
     @Override
     void updateTexture3DImage(Context ctx,
-            int numLevels, int level,
-            int textureFormat, int imageFormat,
-            int width, int height, int depth,
-            int boundaryWidth,
-            int dataType, Object data, boolean useAutoMipMap) {
+                              int numLevels, int level,
+                              int textureFormat, int imageFormat,
+                              int width, int height, int depth,
+                              int boundaryWidth,
+                              int dataType, Object data, boolean useAutoMipMap) {
 
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture3DImage()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         int format = 0;
         int internalFormat = 0;
@@ -5135,12 +5435,11 @@
 
         if (useAutoMipMap) {
             gl.glTexParameteri(GL2.GL_TEXTURE_3D, GL2.GL_GENERATE_MIPMAP, GL.GL_TRUE);
-        }
-        else {
+        } else {
             gl.glTexParameteri(GL2.GL_TEXTURE_3D, GL2.GL_GENERATE_MIPMAP, GL.GL_FALSE);
         }
 
-        if((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) ||
+        if ((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) ||
                 (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_BUFFER)) {
 
             switch (imageFormat) {
@@ -5169,7 +5468,7 @@
                 case ImageComponentRetained.TYPE_BYTE_GRAY:
                     if (internalFormat == GL.GL_ALPHA) {
                         format = GL.GL_ALPHA;
-                    } else  {
+                    } else {
                         format = GL.GL_LUMINANCE;
                     }
                     break;
@@ -5182,21 +5481,20 @@
                     return;
             }
 
-	    if(dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) {
+            if (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) {
 
-            gl.glTexImage3D(GL2.GL_TEXTURE_3D,
-                    level, internalFormat,
-                    width, height, depth, boundaryWidth,
-                    format, GL.GL_UNSIGNED_BYTE, ByteBuffer.wrap((byte[]) data));
-            }
-	    else {
                 gl.glTexImage3D(GL2.GL_TEXTURE_3D,
-                    level, internalFormat,
-                    width, height, depth, boundaryWidth,
-                    format, GL.GL_UNSIGNED_BYTE, (ByteBuffer) data);
-	    }
+                        level, internalFormat,
+                        width, height, depth, boundaryWidth,
+                        format, GL.GL_UNSIGNED_BYTE, ByteBuffer.wrap((byte[]) data));
+            } else {
+                gl.glTexImage3D(GL2.GL_TEXTURE_3D,
+                        level, internalFormat,
+                        width, height, depth, boundaryWidth,
+                        format, GL.GL_UNSIGNED_BYTE, (ByteBuffer) data);
+            }
 
-        } else if((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) ||
+        } else if ((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) ||
                 (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_BUFFER)) {
 
             switch (imageFormat) {
@@ -5213,7 +5511,7 @@
                     format = GL2.GL_BGRA;
                     type = GL2.GL_UNSIGNED_INT_8_8_8_8_REV;
                     break;
-                    /* This method only supports 3 and 4 components formats and INT types. */
+                /* This method only supports 3 and 4 components formats and INT types. */
                 case ImageComponentRetained.TYPE_BYTE_LA:
                 case ImageComponentRetained.TYPE_BYTE_GRAY:
                 case ImageComponentRetained.TYPE_USHORT_GRAY:
@@ -5227,12 +5525,12 @@
             }
 
             /* Force Alpha to 1.0 if needed */
-            if(forceAlphaToOne) {
+            if (forceAlphaToOne) {
                 gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 0.0f);
                 gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 1.0f);
             }
 
-            if(dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) {
+            if (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) {
                 gl.glTexImage3D(GL2.GL_TEXTURE_3D,
                         level, internalFormat,
                         width, height, depth, boundaryWidth,
@@ -5245,7 +5543,7 @@
             }
 
             /* Restore Alpha scale and bias */
-            if(forceAlphaToOne) {
+            if (forceAlphaToOne) {
                 gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 1.0f);
                 gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 0.0f);
             }
@@ -5256,19 +5554,19 @@
 
     @Override
     void updateTexture3DSubImage(Context ctx,
-            int level,
-            int xoffset, int yoffset, int zoffset,
-            int textureFormat, int imageFormat,
-            int imgXOffset, int imgYOffset, int imgZOffset,
-            int tilew, int tileh,
-            int width, int height, int depth,
-            int dataType, Object data, boolean useAutoMipMap) {
+                                 int level,
+                                 int xoffset, int yoffset, int zoffset,
+                                 int textureFormat, int imageFormat,
+                                 int imgXOffset, int imgYOffset, int imgZOffset,
+                                 int tilew, int tileh,
+                                 int width, int height, int depth,
+                                 int dataType, Object data, boolean useAutoMipMap) {
 
         /* Note: useAutoMipMap is not use for SubImage in the jogl pipe */
 
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture3DSubImage()");
 
-		GL2 gl = context(ctx).getGL().getGL2();
+        GL2 gl = context(ctx).getGL().getGL2();
 
         int format = 0;
         int internalFormat = 0;
@@ -5305,7 +5603,7 @@
                 assert false;
         }
 
-        if((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) ||
+        if ((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) ||
                 (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_BUFFER)) {
 
             switch (imageFormat) {
@@ -5340,7 +5638,7 @@
                     if (internalFormat == GL.GL_ALPHA) {
                         format = GL.GL_ALPHA;
                         numBytes = 1;
-                    } else  {
+                    } else {
                         format = GL.GL_LUMINANCE;
                         numBytes = 1;
                     }
@@ -5355,10 +5653,9 @@
             }
 
             ByteBuffer buf = null;
-            if(dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) {
+            if (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) {
                 buf = ByteBuffer.wrap((byte[]) data);
-            }
-            else {
+            } else {
                 buf = (ByteBuffer) data;
             }
 
@@ -5371,7 +5668,7 @@
                     format, GL.GL_UNSIGNED_BYTE,
                     buf);
 
-        } else if((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) ||
+        } else if ((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) ||
                 (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_BUFFER)) {
 
             switch (imageFormat) {
@@ -5388,7 +5685,7 @@
                     format = GL2.GL_BGRA;
                     type = GL2.GL_UNSIGNED_INT_8_8_8_8_REV;
                     break;
-                    /* This method only supports 3 and 4 components formats and INT types. */
+                /* This method only supports 3 and 4 components formats and INT types. */
                 case ImageComponentRetained.TYPE_BYTE_LA:
                 case ImageComponentRetained.TYPE_BYTE_GRAY:
                 case ImageComponentRetained.TYPE_USHORT_GRAY:
@@ -5402,16 +5699,15 @@
             }
 
             /* Force Alpha to 1.0 if needed */
-            if(forceAlphaToOne) {
+            if (forceAlphaToOne) {
                 gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 0.0f);
                 gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 1.0f);
             }
 
             IntBuffer buf = null;
-            if(dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) {
+            if (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) {
                 buf = IntBuffer.wrap((int[]) data);
-            }
-            else {
+            } else {
                 buf = (IntBuffer) data;
             }
 
@@ -5425,7 +5721,7 @@
                     buf);
 
             /* Restore Alpha scale and bias */
-            if(forceAlphaToOne) {
+            if (forceAlphaToOne) {
                 gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 1.0f);
                 gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 0.0f);
             }
@@ -5440,11 +5736,10 @@
 
     }
 
-
     @Override
     void updateTexture3DLodRange(Context ctx,
-            int baseLevel, int maximumLevel,
-            float minimumLod, float maximumLod) {
+                                 int baseLevel, int maximumLevel,
+                                 float minimumLod, float maximumLod) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture3DLodRange()");
 
         updateTextureLodRange(ctx, GL2.GL_TEXTURE_3D,
@@ -5454,8 +5749,8 @@
 
     @Override
     void updateTexture3DLodOffset(Context ctx,
-            float lodOffsetS, float lodOffsetT,
-            float lodOffsetR) {
+                                  float lodOffsetS, float lodOffsetT,
+                                  float lodOffsetR) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture3DLodOffset()");
 
         updateTextureLodOffset(ctx, GL2.GL_TEXTURE_3D,
@@ -5464,10 +5759,10 @@
 
     @Override
     void updateTexture3DBoundary(Context ctx,
-            int boundaryModeS, int boundaryModeT,
-            int boundaryModeR, float boundaryRed,
-            float boundaryGreen, float boundaryBlue,
-            float boundaryAlpha) {
+                                 int boundaryModeS, int boundaryModeT,
+                                 int boundaryModeR, float boundaryRed,
+                                 float boundaryGreen, float boundaryBlue,
+                                 float boundaryAlpha) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture3DBoundary()");
 
         updateTextureBoundary(ctx, GL2.GL_TEXTURE_3D,
@@ -5478,7 +5773,7 @@
 
     @Override
     void updateTexture3DFilterModes(Context ctx,
-            int minFilter, int magFilter) {
+                                    int minFilter, int magFilter) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture3DFilterModes()");
 
         updateTextureFilterModes(ctx, GL2.GL_TEXTURE_3D,
@@ -5487,8 +5782,8 @@
 
     @Override
     void updateTexture3DSharpenFunc(Context ctx,
-            int numSharpenTextureFuncPts,
-            float[] sharpenTextureFuncPts) {
+                                    int numSharpenTextureFuncPts,
+                                    float[] sharpenTextureFuncPts) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture3DSharpenFunc()");
 
         updateTextureSharpenFunc(ctx, GL2.GL_TEXTURE_3D,
@@ -5497,8 +5792,8 @@
 
     @Override
     void updateTexture3DFilter4Func(Context ctx,
-            int numFilter4FuncPts,
-            float[] filter4FuncPts) {
+                                    int numFilter4FuncPts,
+                                    float[] filter4FuncPts) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTexture3DFilter4Func()");
 
         updateTextureFilter4Func(ctx, GL2.GL_TEXTURE_3D,
@@ -5512,13 +5807,6 @@
         updateTextureAnisotropicFilter(ctx, GL2.GL_TEXTURE_3D, degree);
     }
 
-
-    // ---------------------------------------------------------------------
-
-    //
-    // TextureCubeMapRetained methods
-    //
-
     @Override
     void bindTextureCubeMap(Context ctx, int objectId, boolean enable) {
         if (VERBOSE) System.err.println("JoglPipeline.bindTextureCubeMap()");
@@ -5536,11 +5824,11 @@
 
     @Override
     void updateTextureCubeMapImage(Context ctx,
-            int face, int numLevels, int level,
-            int textureFormat, int imageFormat,
-            int width, int height,
-            int boundaryWidth,
-            int dataType, Object data, boolean useAutoMipMap) {
+                                   int face, int numLevels, int level,
+                                   int textureFormat, int imageFormat,
+                                   int width, int height,
+                                   int boundaryWidth,
+                                   int dataType, Object data, boolean useAutoMipMap) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTextureCubeMapImage()");
 
         updateTexture2DImage(ctx, _gl_textureCubeMapFace[face],
@@ -5550,11 +5838,11 @@
 
     @Override
     void updateTextureCubeMapSubImage(Context ctx,
-            int face, int level, int xoffset, int yoffset,
-            int textureFormat,int imageFormat,
-            int imgXOffset, int imgYOffset,
-            int tilew, int width, int height,
-            int dataType, Object data, boolean useAutoMipMap) {
+                                      int face, int level, int xoffset, int yoffset,
+                                      int textureFormat, int imageFormat,
+                                      int imgXOffset, int imgYOffset,
+                                      int tilew, int width, int height,
+                                      int dataType, Object data, boolean useAutoMipMap) {
 
         /* Note: useAutoMipMap is not use for SubImage in the jogl pipe */
 
@@ -5568,8 +5856,8 @@
 
     @Override
     void updateTextureCubeMapLodRange(Context ctx,
-            int baseLevel, int maximumLevel,
-            float minimumLod, float maximumLod) {
+                                      int baseLevel, int maximumLevel,
+                                      float minimumLod, float maximumLod) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTextureCubeMapLodRange()");
 
         updateTextureLodRange(ctx,
@@ -5580,8 +5868,8 @@
 
     @Override
     void updateTextureCubeMapLodOffset(Context ctx,
-            float lodOffsetS, float lodOffsetT,
-            float lodOffsetR) {
+                                       float lodOffsetS, float lodOffsetT,
+                                       float lodOffsetR) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTextureCubeMapLodOffset()");
 
         updateTextureLodOffset(ctx,
@@ -5591,9 +5879,9 @@
 
     @Override
     void updateTextureCubeMapBoundary(Context ctx,
-            int boundaryModeS, int boundaryModeT,
-            float boundaryRed, float boundaryGreen,
-            float boundaryBlue, float boundaryAlpha) {
+                                      int boundaryModeS, int boundaryModeT,
+                                      float boundaryRed, float boundaryGreen,
+                                      float boundaryBlue, float boundaryAlpha) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTextureCubeMapBoundary()");
 
         updateTextureBoundary(ctx,
@@ -5603,9 +5891,11 @@
                 boundaryBlue, boundaryAlpha);
     }
 
+    // The following three methods are used in multi-pass case
+
     @Override
     void updateTextureCubeMapFilterModes(Context ctx,
-            int minFilter, int magFilter) {
+                                         int minFilter, int magFilter) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTextureCubeMapFilterModes()");
 
         updateTextureFilterModes(ctx,
@@ -5615,8 +5905,8 @@
 
     @Override
     void updateTextureCubeMapSharpenFunc(Context ctx,
-            int numSharpenTextureFuncPts,
-            float[] sharpenTextureFuncPts) {
+                                         int numSharpenTextureFuncPts,
+                                         float[] sharpenTextureFuncPts) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTextureCubeMapSharpenFunc()");
 
         updateTextureSharpenFunc(ctx,
@@ -5626,8 +5916,8 @@
 
     @Override
     void updateTextureCubeMapFilter4Func(Context ctx,
-            int numFilter4FuncPts,
-            float[] filter4FuncPts) {
+                                         int numFilter4FuncPts,
+                                         float[] filter4FuncPts) {
         if (VERBOSE) System.err.println("JoglPipeline.updateTextureCubeMapFilter4Func()");
 
         updateTextureFilter4Func(ctx,
@@ -5644,24 +5934,19 @@
                 degree);
     }
 
-    //----------------------------------------------------------------------
-    //
-    // Helper routines for above texture methods
-    //
-
     private void updateTexture2DImage(Context ctx,
-            int target,
-            int numLevels,
-            int level,
-            int textureFormat,
-            int imageFormat,
-            int width,
-            int height,
-            int boundaryWidth,
-            int dataType,
-            Object data,
-            boolean useAutoMipMap) {
-		GL2 gl = context(ctx).getGL().getGL2();
+                                      int target,
+                                      int numLevels,
+                                      int level,
+                                      int textureFormat,
+                                      int imageFormat,
+                                      int width,
+                                      int height,
+                                      int boundaryWidth,
+                                      int dataType,
+                                      Object data,
+                                      boolean useAutoMipMap) {
+        GL2 gl = context(ctx).getGL().getGL2();
 
         int format = 0, internalFormat = 0;
         int type = GL2.GL_UNSIGNED_INT_8_8_8_8;
@@ -5692,12 +5977,11 @@
 
         if (useAutoMipMap) {
             gl.glTexParameteri(target, GL2.GL_GENERATE_MIPMAP, GL.GL_TRUE);
-        }
-        else {
+        } else {
             gl.glTexParameteri(target, GL2.GL_GENERATE_MIPMAP, GL.GL_FALSE);
         }
 
-        if((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) ||
+        if ((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) ||
                 (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_BUFFER)) {
 
             switch (imageFormat) {
@@ -5726,7 +6010,7 @@
                 case ImageComponentRetained.TYPE_BYTE_GRAY:
                     if (internalFormat == GL.GL_ALPHA) {
                         format = GL.GL_ALPHA;
-                    } else  {
+                    } else {
                         format = GL.GL_LUMINANCE;
                     }
                     break;
@@ -5739,18 +6023,18 @@
                     return;
             }
 
-            if(dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) {
+            if (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) {
 
                 gl.glTexImage2D(target, level, internalFormat,
                         width, height, boundaryWidth,
-                        format, GL.GL_UNSIGNED_BYTE, ByteBuffer.wrap((byte[])data));
+                        format, GL.GL_UNSIGNED_BYTE, ByteBuffer.wrap((byte[]) data));
             } else {
                 gl.glTexImage2D(target, level, internalFormat,
                         width, height, boundaryWidth,
                         format, GL.GL_UNSIGNED_BYTE, (Buffer) data);
             }
 
-        } else if((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) ||
+        } else if ((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) ||
                 (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_BUFFER)) {
 
             switch (imageFormat) {
@@ -5767,7 +6051,7 @@
                     format = GL2.GL_BGRA;
                     type = GL2.GL_UNSIGNED_INT_8_8_8_8_REV;
                     break;
-                    /* This method only supports 3 and 4 components formats and INT types. */
+                /* This method only supports 3 and 4 components formats and INT types. */
                 case ImageComponentRetained.TYPE_BYTE_LA:
                 case ImageComponentRetained.TYPE_BYTE_GRAY:
                 case ImageComponentRetained.TYPE_USHORT_GRAY:
@@ -5781,15 +6065,15 @@
             }
 
             /* Force Alpha to 1.0 if needed */
-            if(forceAlphaToOne) {
+            if (forceAlphaToOne) {
                 gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 0.0f);
                 gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 1.0f);
             }
 
-            if(dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) {
+            if (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) {
                 gl.glTexImage2D(target, level, internalFormat,
                         width, height, boundaryWidth,
-                        format, type, IntBuffer.wrap((int[])data));
+                        format, type, IntBuffer.wrap((int[]) data));
             } else {
                 gl.glTexImage2D(target, level, internalFormat,
                         width, height, boundaryWidth,
@@ -5797,7 +6081,7 @@
             }
 
             /* Restore Alpha scale and bias */
-            if(forceAlphaToOne) {
+            if (forceAlphaToOne) {
                 gl.glPixelTransferf(GL2.GL_ALPHA_SCALE, 1.0f);
                 gl.glPixelTransferf(GL2.GL_ALPHA_BIAS, 0.0f);
             }
@@ -5807,15 +6091,15 @@
     }
 
     private void updateTexture2DSubImage(Context ctx,
-            int target,
-            int level, int xoffset, int yoffset,
-            int textureFormat, int imageFormat,
-            int imgXOffset, int imgYOffset,
-            int tilew, int width, int height,
-            int dataType, Object data) {
-		GL2 gl = context(ctx).getGL().getGL2();
+                                         int target,
+                                         int level, int xoffset, int yoffset,
+                                         int textureFormat, int imageFormat,
+                                         int imgXOffset, int imgYOffset,
+                                         int tilew, int width, int height,
+                                         int dataType, Object data) {
+        GL2 gl = context(ctx).getGL().getGL2();
 
-        int format = 0, internalFormat=0;
+        int format = 0, internalFormat = 0;
         int numBytes = 0;
         int type = GL2.GL_UNSIGNED_INT_8_8_8_8;
         boolean forceAlphaToOne = false;
@@ -5849,7 +6133,7 @@
                 assert false;
         }
 
-        if((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) ||
+        if ((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) ||
                 (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_BUFFER)) {
 
             switch (imageFormat) {
@@ -5884,7 +6168,7 @@
                     if (internalFormat == GL.GL_ALPHA) {
                         format = GL.GL_ALPHA;
                         numBytes = 1;
-                    } else  {
+                    } else {
                         format = GL.GL_LUMINANCE;
                         numBytes = 1;
                     }
@@ -5899,10 +6183,9 @@
             }
 
             ByteBuffer buf = null;
-            if(dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) {
+            if (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_BYTE_ARRAY) {
                 buf = ByteBuffer.wrap((byte[]) data);
-            }
-            else {
+            } else {
                 buf = (ByteBuffer) data;
             }
 
@@ -5911,7 +6194,7 @@
             gl.glTexSubImage2D(target, level, xoffset, yoffset, width, height,
                     format, GL.GL_UNSIGNED_BYTE, buf);
 
-        } else if((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) ||
+        } else if ((dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_ARRAY) ||
                 (dataType == ImageComponentRetained.IMAGE_DATA_TYPE_INT_BUFFER)) {
 
             switch (imageFormat) {
